Package: RNAseqCovarImpute
Title: Impute Covariate Data in RNA Sequencing Studies
Version: 1.9.0
Authors@R: c(
    person("Brennan", "Baker", email = "brennanhilton@gmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5459-9141")),
    person("Sheela", "Sathyanarayana", role = "aut"),
    person("Adam", "Szpiro", role = "aut"),
    person("James", "MacDonald", role = "aut"),
    person("Alison", "Paquette", role = "aut"))    
URL: https://github.com/brennanhilton/RNAseqCovarImpute
BugReports: https://github.com/brennanhilton/RNAseqCovarImpute/issues
Description: The RNAseqCovarImpute package makes linear model analysis for RNA sequencing read counts
    compatible with multiple imputation (MI) of missing covariates. A major problem with implementing
    MI in RNA sequencing studies is that the outcome data must be included in the imputation prediction
    models to avoid bias. This is difficult in omics studies with high-dimensional data. The first method
    we developed in the RNAseqCovarImpute package surmounts the problem of high-dimensional outcome data
    by binning genes into smaller groups to analyze pseudo-independently. This method implements covariate
    MI in gene expression studies by 1) randomly binning genes into smaller groups, 2) creating M imputed
    datasets separately within each bin, where the imputation predictor matrix includes all covariates and
    the log counts per million (CPM) for the genes within each bin, 3) estimating gene expression changes
    using `limma::voom` followed by `limma::lmFit` functions, separately on each M imputed dataset within
    each gene bin, 4) un-binning the gene sets and stacking the M sets of model results before applying the
    `limma::squeezeVar` function to apply a variance shrinking Bayesian procedure to each M set of model
    results, 5) pooling the results with Rubins’ rules to produce combined coefficients, standard errors,
    and P-values, and 6) adjusting P-values for multiplicity to account for false discovery rate (FDR). A
    faster method uses principal component analysis (PCA) to avoid binning genes while still retaining
    outcome information in the MI models. Binning genes into smaller groups requires that the MI and
    limma-voom analysis is run many times (typically hundreds). The more computationally efficient MI PCA
    method implements covariate MI in gene expression studies by 1) performing PCA on the log CPM values for
    all genes using the Bioconductor `PCAtools` package, 2) creating M imputed datasets where the imputation
    predictor matrix includes all covariates and the optimum number of PCs to retain (e.g., based on Horn’s
    parallel analysis or the number of PCs that account for >80% explained variation), 3) conducting the
    standard limma-voom pipeline with the `voom` followed by `lmFit` followed by `eBayes` functions on each
    M imputed dataset, 4) pooling the results with Rubins’ rules to produce combined coefficients, standard
    errors, and P-values, and 5) adjusting P-values for multiplicity to account for false discovery rate (FDR).
License: GPL-3
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
VignetteBuilder: knitr
biocViews: RNASeq, GeneExpression, DifferentialExpression, Sequencing
Suggests: BiocStyle, knitr, PCAtools, rmarkdown, tidyr, stringr,
        testthat (>= 3.0.0)
Depends: R (>= 4.3.0)
Imports: Biobase, BiocGenerics, BiocParallel, stats, limma, dplyr,
        magrittr, rlang, edgeR, foreach, mice
Config/testthat/edition: 3
Collate: 'RNAseqCovarImpute-package.R' 'combine_rubins.R'
        'combine_rubins_pca.R' 'example_DGE.R' 'example_data.R'
        'get_gene_bin_intervals.R' 'impute_by_gene_bin_helper.R'
        'impute_by_gene_bin.R' 'voom_sx_sy.R' 'lowess_all_gene_bins.R'
        'voom_master_lowess.R' 'limmavoom_imputed_data_list_helper.R'
        'limmavoom_imputed_data_list.R'
        'limmavoom_imputed_data_pca_helper.R'
        'limmavoom_imputed_data_pca.R'
git_url: https://git.bioconductor.org/packages/RNAseqCovarImpute
git_branch: devel
git_last_commit: c21a243
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 22:44:22 UTC; biocbuild
Author: Brennan Baker [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5459-9141>),
  Sheela Sathyanarayana [aut],
  Adam Szpiro [aut],
  James MacDonald [aut],
  Alison Paquette [aut]
Maintainer: Brennan Baker <brennanhilton@gmail.com>

Impute Covariate Data in RNA-sequencing Studies
================

# Introduction

The RNAseqCovarImpute package makes linear model analysis for RNA-seq
read counts compatible with multiple imputation (MI) of missing
covariates. Relying on the Bioconductor `limma` package,
RNAseqCovarImpute is included in Bioconductor as an extension of the
[variance modeling at the observational level (voom)
method](https://doi.org/10.1186/gb-2014-15-2-r29) which can be applied
in circumstances with missing covariate data.

Missing data is a common problem in observational studies, as modeling
techniques such as linear regression cannot be fit to data with missing
points. Missing data is frequently handled using complete case analyses
in which any individuals with missing data are dropped from the study.
Dropping participants can reduce statistical power and, in some cases,
result in biased model estimates. A common technique to address these
problems is to replace or ‘impute’ missing data points with substituted
values. Typically, for a given covariate, missing data points are
imputed using a prediction model including other relevant covariates as
independent variables. In single imputation, a missing value is replaced
with the most likely value based on the predictive model. However, by
ignoring the uncertainty inherent with predicting missing data, single
imputation methods can result in biased coefficients and over-confident
standard errors. MI addresses this problem by generating several
predictions, thereby allowing for uncertainty about the missing data. In
a typical MI procedure: 1) M imputed data sets are created, 2) each data
set is analyzed separately (e.g., using linear regression), and 3)
estimates and standard errors across the M analyses are pooled using
Rubin’s rules. A major problem with implementing MI in RNA sequencing
studies is that the outcome data must be included in the imputation
prediction models to avoid bias. This is difficult in omics studies with
high-dimensional data.

The first method we developed in the RNAseqCovarImpute package surmounts
the problem of high-dimensional outcome data by binning genes into
smaller groups to analyze pseudo-independently. This method implements
covariate MI in gene expression studies by 1) randomly binning genes
into smaller groups, 2) creating M imputed datasets separately within
each bin, where the imputation predictor matrix includes all covariates
and the log counts per million (CPM) for the genes within each bin, 3)
estimating gene expression changes using `limma::voom` followed by
`limma::lmFit` functions, separately on each M imputed dataset within
each gene bin, 4) un-binning the gene sets and stacking the M sets of
model results before applying the `limma::squeezeVar` function to apply
a variance shrinking Bayesian procedure to each M set of model results,
5) pooling the results with Rubins’ rules to produce combined
coefficients, standard errors, and P-values, and 6) adjusting P-values
for multiplicity to account for false discovery rate (FDR).

A faster method uses principal component analysis (PCA) to avoid binning
genes while still retaining outcome information in the MI models.
Binning genes into smaller groups requires that the MI and limma-voom
analysis is run many times (typically hundreds). The more
computationally efficient MI PCA method implements covariate MI in gene
expression studies by 1) performing PCA on the log CPM values for all
genes using the Bioconductor `PCAtools` package, 2) creating M imputed
datasets where the imputation predictor matrix includes all covariates
and the optimum number of PCs to retain (e.g., based on Horn’s parallel
analysis or the number of PCs that account for \>80% explained
variation), 3) conducting the standard limma-voom pipeline with the
`voom` followed by `lmFit` followed by `eBayes` functions on each M
imputed dataset, 4) pooling the results with Rubins’ rules to produce
combined coefficients, standard errors, and P-values, and 5) adjusting
P-values for multiplicity to account for false discovery rate (FDR).

# Installation

``` r
# Install from github
library(devtools)
install_github("brennanhilton/RNAseqCovarImpute")

# Install from Bioconductor (not yet on Bioconductor)

if (!require("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("RNAseqCovarImpute")
```

# Generate random data with missing covariate data

Normally you would have your own covariate and RNA-sequencing data. We
generated random data for the purpose of this demonstration. The exact
code used to generate these data are found in the [Example Data for
RNAseqCovarImpute](Example_Data_for_RNAseqCovarImpute.html) vignette. In
short, `example_data` contains 500 rows with data for variables x, y,
and z, which are continuous normally distributed, and a and b, which are
binary variables. Missigness was simulated for all variables other than
x such that a complete case analysis would drop 24.2% of participants.
`example_DGE` contains random count data from the Poisson distribution
for 500 made up genes, ENS1-ENS500

``` r
library(RNAseqCovarImpute)
library(dplyr)
```

    ## 
    ## Attaching package: 'dplyr'

    ## The following objects are masked from 'package:stats':
    ## 
    ##     filter, lag

    ## The following objects are masked from 'package:base':
    ## 
    ##     intersect, setdiff, setequal, union

``` r
library(BiocParallel)
library(PCAtools)
```

    ## Loading required package: ggplot2

    ## Loading required package: ggrepel

    ## 
    ## Attaching package: 'PCAtools'

    ## The following objects are masked from 'package:stats':
    ## 
    ##     biplot, screeplot

``` r
library(limma)
library(mice)
```

    ## 
    ## Attaching package: 'mice'

    ## The following object is masked from 'package:stats':
    ## 
    ##     filter

    ## The following objects are masked from 'package:base':
    ## 
    ##     cbind, rbind

``` r
data(example_data)
data(example_DGE)
```

# RNAseqCovarImpute Demonstration

## MI PCA method

We demonstrate the MI PCA method first, as it is far faster and performs
just as well, or even better in many cases, compared with the original
gene binning method.

### Conduct PCA

``` r
# We use voom to convert counts to logCPM values, adding 0.5 to all the counts to avoid taking the logarithm of zero, and normalized for library size.
start.pca = Sys.time() # To calculate runtime
pca_data = limma::voom(example_DGE)$E
# Conduct pca
p = PCAtools::pca(pca_data)
# Determine the number of PCs that account for >80% explained variation
which(cumsum(p$variance) > 80)[1]
```

    ## PC78 
    ##   78

``` r
# Extract the PCs and append to our data
pcs = p$rotated[,1:78]
example_data = cbind(example_data, pcs)
```

### Conduct MI with mice

``` r
# Conduct mice. In practice, m should be much larger (e.g., 10-100)
imp = mice::mice(example_data, m=3)
```

    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b

### Conduct limma-voom analysis

Now we use our `limmavoom_imputed_data_pca` function to run the standard
limma-voom pipeline on each MI dataset and then pool the results with
Rubins’ rules. This procedure is run in parallel using the BiocParallel
package with the default back-end. Users can change the back-end using
the `BPPARAM` argument. This argument is passed to
`BiocParallel::bplapply`. For instance, below we specify to run
`limmavoom_imputed_data_pca` in serial. Users specify the formula for
the RNA-seq design matrix for which log fold-changes will be estimated.
For each contrast specified in the voom_formula, p-values, coefficients,
and standard errors are stored under the “\_p”, “\_coef” and “\_se”
columns, respectively.

``` r
mi_pca_res = RNAseqCovarImpute::limmavoom_imputed_data_pca(imp = imp,
                                                           DGE = example_DGE,
                                                           voom_formula = "~x + y + z + a + b",
                                                           BPPARAM = SerialParam())

# Display the results for the first 5 genes for the x variable in the model.
mi_pca_res[1:5, grep("^x", colnames(mi_pca_res))]
```

    ##          x_p        x_coef        x_se
    ## 1 0.06037941  0.0172257239 0.009159629
    ## 2 0.97214805 -0.0001254919 0.003593184
    ## 3 0.16183199 -0.0043427912 0.003101565
    ## 4 0.35100300 -0.0043740371 0.004687267
    ## 5 0.80060273 -0.0017828965 0.007056803

### Adjust for FDR

For a given contrast based on the variables in the design matrix
(voom_formula), we arrange the genes from lowest to highest p-value and
adjust for FDR.

``` r
mi_pca_res_x = mi_pca_res %>% 
  arrange(x_p) %>% 
  mutate(x_p_adj = p.adjust(x_p, method = "fdr")) %>% 
  dplyr::select(probe, x_coef, x_p, x_p_adj)

end.pca = Sys.time() # To calculate runtime
time.pca = end.pca - start.pca # To calculate runtime
# Display the results for the first 5 genes
mi_pca_res_x[1:5,]
```

    ##    probe      x_coef          x_p    x_p_adj
    ## 1 ENS432 -0.02124923 0.0001616095 0.08080476
    ## 2  ENS65 -0.02252621 0.0019819761 0.49549403
    ## 3 ENS327 -0.01044210 0.0062146233 0.91013120
    ## 4 ENS239  0.01454005 0.0072810496 0.91013120
    ## 5 ENS411  0.02146120 0.0111108560 0.97182262

## Gene binning MI method

### Bin the genes into smaller groups

The default is approximately 1 gene per 10 individuals in the study, but
the user can specify a different ratio. For example, in a study with 500
participants and 10,000 genes, 200 bins of 50 genes would be created
using the default ratio. This example demonstrates why this method can
be computationally intensive: the MI and limma-voom analysis will be
conducted separately 200 times. When the total number of genes is not
divisible by the bin size, the method flexibly creates bins of different
sizes. The order of the features (e.g., ENSEMBL gene identifiers) should
be randomized before binning.

``` r
# Get back the original example_data without the PCs appended
data(example_data)
start.old.method = Sys.time() # To calculate runtime
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
```

| start | end | number |
|------:|----:|-------:|
|     1 |  50 |     50 |
|    51 | 100 |     50 |
|   101 | 150 |     50 |
|   151 | 200 |     50 |
|   201 | 250 |     50 |
|   251 | 300 |     50 |
|   301 | 350 |     50 |
|   351 | 400 |     50 |
|   401 | 450 |     50 |
|   451 | 500 |     50 |

The first 10 gene bins. Start and end columns indicate row numbers for
the beginning and end of each bin. Number indicates the number of genes
in each bin.

Our goal is to bin genes randomly, so we must randomize the order of the
genes in our DGE list. Without this step, genes would be binned together
based on their sequential order within the chosen gene annotation (e.g.,
ENSEMBL or ENTREZ).

``` r
# Randomize the order of gene identifiers
annot <- example_DGE$genes
annot <- annot[sample(seq_len(nrow(annot))), ]
# Match order of the genes in the DGE to the randomized order of genes in the annotation
example_DGE <- example_DGE[annot, ]
```

### Make imputed data sets for each bin of genes and conduct differential expression analysis

Data are imputed using the mice R package with its default predictive
modeling methods, which are predictive mean matching, logistic
regression, polytomous regression, and proportional odds modeling for
continuous, binary, categorical, and unordered variables, respectively.
The user may specify “m”, the number of imputed datasets, and “maxit”,
the number of iterations for each imputation (default = 10). M imputed
datasets are created separately for each gene bin, where the imputation
predictor matrix includes all covariates along with the log-CPM for all
the genes in a particular bin. Thus, each gene bin contains M sets of
imputed data.

The `impute_by_gene_bin` function loops through a DGE list using the
gene bin intervals from the `get_gene_bin_intervals` function. It
returns a list of sets of m imputed datasets, one per gene bin. For
instance, if m = 100 and intervals contains 200 gene bin intervals,
output will be a list of 200 sets of 100 imputed datasets. Each of the
200 sets are imputed using only the genes in one gene bin.

``` r
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3
)
```

    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b

This procedure is run in parallel using the BiocParallel package with
the default back-end. Users can change the back-end using the `BPPARAM`
argument. This argument is passed to `BiocParallel::bplapply`. For
instance, to run `gene_bin_impute` in serial:

``` r
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3,
    BPPARAM = SerialParam()
)
```

    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b
    ## 
    ##  iter imp variable
    ##   1   1  y  z  a  b
    ##   1   2  y  z  a  b
    ##   1   3  y  z  a  b
    ##   2   1  y  z  a  b
    ##   2   2  y  z  a  b
    ##   2   3  y  z  a  b
    ##   3   1  y  z  a  b
    ##   3   2  y  z  a  b
    ##   3   3  y  z  a  b
    ##   4   1  y  z  a  b
    ##   4   2  y  z  a  b
    ##   4   3  y  z  a  b
    ##   5   1  y  z  a  b
    ##   5   2  y  z  a  b
    ##   5   3  y  z  a  b
    ##   6   1  y  z  a  b
    ##   6   2  y  z  a  b
    ##   6   3  y  z  a  b
    ##   7   1  y  z  a  b
    ##   7   2  y  z  a  b
    ##   7   3  y  z  a  b
    ##   8   1  y  z  a  b
    ##   8   2  y  z  a  b
    ##   8   3  y  z  a  b
    ##   9   1  y  z  a  b
    ##   9   2  y  z  a  b
    ##   9   3  y  z  a  b
    ##   10   1  y  z  a  b
    ##   10   2  y  z  a  b
    ##   10   3  y  z  a  b

### Estimate gene expression changes using voom followed by lmFit functions, separately on each M imputed dataset within each gene bin

The `limmavoom_imputed_data_list` function loops through the imputed
data list (output from `impute_by_gene_bin` function) and runs RNA-seq
analysis with the limma-voom pipeline. Users specify the formula for the
RNA-seq design matrix for which log fold-changes will be estimated. This
procedure can also be run with a different parallel back-end or in
serial using the `BPPARAM` argument as above.

``` r
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 3,
    voom_formula = "~x + y + z + a + b"
)
```

    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## 
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`
    ## Joining with `by = join_by(probe)`

### Apply variance shrinking Bayesian procedure, pooling results with Rubins’ rules, and FDR-adjust P-values

The final step is to combine the results from each imputed dataset using
Rubin’s rules. The argument “model_results” is the output from the
`limmavoom_imputed_data_list` function above. The `combine_rubins`
function applies the `squeezeVar` function before pooling results. The
result is a table with one row per gene. The table includes coefficients
(e.g., logFC values) standard errors, degrees of freedom, t-statistics,
P-Values, and adjusted P-values from the limma-voom pipeline. Both the
raw and empirical Bayes moderated statistics are reported. The user
selects the predictor of interest in the form of a linear model contrast
for which model results will be extracted. For a continuous variable
this is just the predictor name. For a categorical variable like `b` in
`example_data` we could specify `predictor = b1` to get the effect of
being in the b = 1 versus the b = 0 group.

``` r
final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)

end.old.method = Sys.time() # To calculate runtime
time.old.method = end.old.method - start.old.method
```

| probe  | coef_combined | combined_p_bayes | combined_p_adj_bayes |
|:-------|--------------:|-----------------:|---------------------:|
| ENS432 |        -0.021 |            0.000 |                0.092 |
| ENS65  |        -0.022 |            0.002 |                0.537 |
| ENS327 |        -0.011 |            0.006 |                0.987 |
| ENS239 |         0.014 |            0.009 |                0.987 |
| ENS411 |         0.022 |            0.010 |                0.987 |
| ENS260 |         0.011 |            0.012 |                0.987 |
| ENS107 |         0.007 |            0.022 |                0.987 |
| ENS291 |         0.016 |            0.024 |                0.987 |
| ENS219 |         0.012 |            0.026 |                0.987 |
| ENS458 |         0.014 |            0.025 |                0.987 |

The top 10 genes associated with predictor x sorted by lowest P-value

The old method took more time(`time.old.method`) compared with the MI
PCA method (`time.pca`).

# Session info

    ## R version 4.3.3 (2024-02-29 ucrt)
    ## Platform: x86_64-w64-mingw32/x64 (64-bit)
    ## Running under: Windows 10 x64 (build 19045)
    ## 
    ## Matrix products: default
    ## 
    ## 
    ## locale:
    ## [1] LC_COLLATE=English_United States.utf8 
    ## [2] LC_CTYPE=English_United States.utf8   
    ## [3] LC_MONETARY=English_United States.utf8
    ## [4] LC_NUMERIC=C                          
    ## [5] LC_TIME=English_United States.utf8    
    ## 
    ## time zone: America/Los_Angeles
    ## tzcode source: internal
    ## 
    ## attached base packages:
    ## [1] stats     graphics  grDevices utils     datasets  methods   base     
    ## 
    ## other attached packages:
    ## [1] mice_3.16.0             limma_3.56.2            PCAtools_2.12.0        
    ## [4] ggrepel_0.9.3           ggplot2_3.4.4           BiocParallel_1.34.2    
    ## [7] dplyr_1.1.0             RNAseqCovarImpute_1.1.2
    ## 
    ## loaded via a namespace (and not attached):
    ##  [1] tidyselect_1.2.0          fastmap_1.1.1            
    ##  [3] digest_0.6.31             rsvd_1.0.5               
    ##  [5] rpart_4.1.23              lifecycle_1.0.3          
    ##  [7] survival_3.5-8            magrittr_2.0.3           
    ##  [9] compiler_4.3.3            rlang_1.1.1              
    ## [11] tools_4.3.3               utf8_1.2.3               
    ## [13] yaml_2.3.7                knitr_1.43               
    ## [15] S4Arrays_1.0.6            dqrng_0.3.0              
    ## [17] DelayedArray_0.26.7       plyr_1.8.8               
    ## [19] abind_1.4-5               withr_2.5.0              
    ## [21] purrr_1.0.1               BiocGenerics_0.46.0      
    ## [23] nnet_7.3-19               grid_4.3.3               
    ## [25] stats4_4.3.3              fansi_1.0.4              
    ## [27] jomo_2.7-6                beachmat_2.16.0          
    ## [29] colorspace_2.1-0          edgeR_3.42.4             
    ## [31] scales_1.2.1              iterators_1.0.14         
    ## [33] MASS_7.3-60.0.1           cli_3.6.0                
    ## [35] rmarkdown_2.20            crayon_1.5.2             
    ## [37] generics_0.1.3            rstudioapi_0.14          
    ## [39] reshape2_1.4.4            DelayedMatrixStats_1.22.6
    ## [41] minqa_1.2.5               stringr_1.5.0            
    ## [43] splines_4.3.3             parallel_4.3.3           
    ## [45] matrixStats_1.0.0         vctrs_0.5.2              
    ## [47] boot_1.3-29               glmnet_4.1-7             
    ## [49] Matrix_1.6-5              BiocSingular_1.16.0      
    ## [51] IRanges_2.33.0            S4Vectors_0.37.4         
    ## [53] mitml_0.4-5               irlba_2.3.5.1            
    ## [55] locfit_1.5-9.7            foreach_1.5.2            
    ## [57] tidyr_1.3.0               snow_0.4-4               
    ## [59] glue_1.6.2                nloptr_2.0.3             
    ## [61] pan_1.8                   codetools_0.2-19         
    ## [63] cowplot_1.1.1             stringi_1.7.12           
    ## [65] shape_1.4.6               gtable_0.3.1             
    ## [67] ScaledMatrix_1.8.1        lme4_1.1-34              
    ## [69] munsell_0.5.0             tibble_3.2.0             
    ## [71] pillar_1.9.0              htmltools_0.5.4          
    ## [73] R6_2.5.1                  sparseMatrixStats_1.12.2 
    ## [75] evaluate_0.21             lattice_0.22-5           
    ## [77] backports_1.4.1           broom_1.0.5              
    ## [79] Rcpp_1.0.10               nlme_3.1-164             
    ## [81] xfun_0.39                 MatrixGenerics_1.12.3    
    ## [83] pkgconfig_2.0.3

#' limmavoom_imputed_data_pca_helper
#'
#' Runs limma-voom pipeline on one of the m imputed datasets and returns the coefficients, 
#' Bayesian moderated standard errors and degrees of freedom.
#' This function used while looping through the m imputed datasets.
#' @return A list with coefficients, standard errors, and total degrees of freedom values from limma-voom gene expression analysis.
#' @param i Number from 1-m
#' @param imp Imputed data from mice (mids object)
#' @param DGE A DGEList object.
#' @param voom_formula Formula for design matrix.
#'
#' @importFrom stats model.matrix
#' @importFrom limma eBayes voom lmFit
#' @importFrom mice complete
#' 
#' @keywords internal
limmavoom_imputed_data_pca_helper <- function(i, imp, DGE, voom_formula) {
  # Get imputed data
  imputed_data_i <- mice::complete(imp, i)
  # Design matrix
  design <- model.matrix(as.formula(voom_formula), imputed_data_i)
  # Linear model fitting and empirical Bayes moderation
  eout <- limma::eBayes(limma::lmFit(limma::voom(DGE, design = design)))
  # Extract coefficients and standard errors
  coef <- as.data.frame(eout$coefficients)
  SE <- as.data.frame(sqrt(eout$s2.post) * eout$stdev.unscaled)
  df <- eout$df.total[[1]]
  # Return the result as a list
  return(list(coef = coef, SE = SE, df = df))
}

#' Simulated dataset
#'
#' The exact code used to generate these data are found in the Example_Data_for_RNAseqCovarImpute
#' vignette. In short, `example_data` contains 500 rows with data for variables x, y, and z, which
#' are continuous normally distributed, and a and b, which are binary variables. Missigness
#' was simulated for all variables other than x such that a complete case analysis would drop
#' 24.2% of participants. `example_DGE` contains random count data from the Poisson distribution
#' for 500 made up genes, ENS1-ENS500
#'
#' @format ## `example_data`
#' data frame with 500 rows and 5 variables
#' \describe{
#' \item{x}{continuous normally distributed}
#' \item{y}{continuous normally distributed}
#' \item{z}{continuous normally distributed}
#' \item{a}{binary}
#' \item{b}{binary}
#' ...
#' }
#' @return Tibble with 500 rows of data for variables x, y, and z
#' @docType data
#' @keywords datasets
#' @name example_data
#' @usage data(example_data)
#' @examples
#' data(example_data)
"example_data"

## ----message=FALSE, warning=FALSE, eval = requireNamespace(c("stringr", "tidyr"))----
library(dplyr)
library(stringr)
library(tidyr)
library(edgeR)
library(mice)
# Generate random covariate data
set.seed(2023)
x1 <- rnorm(n = 500)
y1 <- rnorm(n = 500)
z1 <- rnorm(n = 500)
a1 <- rbinom(n = 500, prob = .25, size = 1)
b1 <- rbinom(n = 500, prob = .5, size = 1)
data <- data.frame(x = x1, y = y1, z = z1, a = a1, b = b1)

# Generate random count data from Poisson distribution
nsamp <- nrow(data)
ngene <- 500
mat <- matrix(stats::rpois(n = nsamp * ngene, lambda = sample(1:500, ngene, replace = TRUE)),
    nrow = ngene,
    ncol = nsamp
)

# Make fake ENSEMBL gene numbers
annot <- tibble(number = seq_len(ngene), name1 = "ENS") %>%
    mutate(ENSEMBL = str_c(name1, number)) %>%
    dplyr::select(ENSEMBL)
rownames(mat) <- annot$ENSEMBL

# Make DGE list and set rownames to ENSEMBL gene numbers above
example_DGE <- DGEList(mat, genes = annot)
rownames(example_DGE) <- annot$ENSEMBL

## ----message=FALSE, warning=FALSE---------------------------------------------
# First get all combos of 0 or 1 for the 4 other variables (y, z, a, and b)
pattern_vars <- expand.grid(c(0, 1), c(0, 1), c(0, 1), c(0, 1))
# Then add back a column for the predictor of interest, which is never amputed, so the first col =1 the whole way down
pattern2 <- matrix(1, nrow = nrow(pattern_vars), ncol = 1)
pattern1 <- cbind(pattern2, pattern_vars)
# Remove last row which is all 1s (all 1s means no missingness induced)
pattern <- pattern1[seq_len(15), ]

# Specify proportion of missing data and missingness mechanism for the ampute function
prop_miss <- 25
miss_mech <- "MAR"
result <- ampute(data = data, prop = prop_miss, mech = miss_mech, patterns = pattern)

# Extract the missing data
example_data <- result$amp
# Ampute function turns factors to numeric, so convert back to factors
example_data <- example_data %>% mutate(
    a = as.factor(a),
    b = as.factor(b)
)

# Calculate the new sample size if NAs are dropped as in a complete case analysis
sample_size <- example_data %>%
    drop_na() %>%
    nrow()

# As shown below, we have 24.2% missingness.
100 * (nsamp - sample_size) / nsamp

## ----message=FALSE, warning=FALSE, echo=FALSE---------------------------------
example_data %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The first 10 rows of simulated covariate data with missingness")

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' combine_rubins
#'
#' Combines results from each imputed dataset using Rubin's rules.
#' @return Dataframe with one row per gene containing coefficients standard errors, degrees of freedom, t-statistics, P-Values, and adjusted P-values from the limma-voom pipeline.
#' \item{coef_combined}{combined logFCs across the multiple imputed datasets using Rubin's rules}
#' \item{SE_P}{pooled standard error across the multiple imputed datasets using Rubin's rules}
#' \item{SE_P_bayes}{pooled standard error across the multiple imputed datasets using Rubin's rules squeezed to global mean variance trend curve with limma-voom Bayesian procedure}
#' \item{df}{limma-voom residual degrees of freedom adjusted for Rubin's rules}
#' \item{df_bayes}{limma-voom residual degrees of freedom adjusted for Rubin's rules and Bayesian procedure}
#' \item{rubins_t}{t-statistic = coef_combined divided by SE_p}
#' \item{rubins_t_bayes}{t-statistic = coef_combined divided by SE_p_bayes}
#' \item{combined_p}{p-value from two-sided t-distribution alpha = 0.05 using rubins_t}
#' \item{combined_p_bayes}{p-value from two-sided t-distribution alpha = 0.05 using rubins_t_bayes}
#' \item{combined_p_adj}{false discovery rate (FDR) adjusted combined_p}
#' \item{combined_p_adj_bayes}{false discovery rate (FDR) adjusted combined_p_bayes}
#' @param DGE A DGEList object.
#' @param model_results Output from limmavoom_imputed_datalist.
#' @param predictor Independent variable of interest, in the form of a linear model contrast. Must be a variable in voom_formula.
#' @param covariate Arguments passed to limma::squeezeVar. If non-NULL, var.prior will depend on this numeric covariate. Otherwise, var.prior is constant.
#' @param robust Arguments passed to limma::squeezeVar. Llogical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?
#' @param winsor.tail.p Arguments passed to limma::squeezeVar. Numeric vector of length 1 or 2, giving left and right tail proportions of x to Winsorize. Used only when robust=TRUE.
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr select starts_with mutate tibble arrange contains pull
#' @importFrom stats p.adjust pt
#' @importFrom rlang := .data
#' @importFrom limma squeezeVar
#' @importFrom foreach foreach %do%
#'
#' @examples
#' data(example_data)
#' data(example_DGE)
#' intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
#' gene_bin_impute <- impute_by_gene_bin(example_data,
#'     intervals,
#'     example_DGE,
#'     m = 2
#' )
#' coef_se <- limmavoom_imputed_data_list(
#'     gene_intervals = intervals,
#'     DGE = example_DGE,
#'     imputed_data_list = gene_bin_impute,
#'     m = 2,
#'     voom_formula = "~x + y + z + a + b"
#' )
#'
#' final_res <- combine_rubins(
#'     DGE = example_DGE,
#'     model_results = coef_se,
#'     predictor = "x"
#' )
#' @export


combine_rubins <- function(DGE, model_results, predictor, covariate = NULL, robust = FALSE, winsor.tail.p = c(0.05, 0.1)) {
    # Validity tests
    if (!class(DGE) %in% "DGEList") {
        stop("Input 'DGE' is not a valid DGEList object.")
    }
    if (!any((class(model_results) %in% c("tbl_df", "tbl", "data.frame")))) {
        stop("Input 'model_results' is not a valid data.frame, tbl, or tbl_df object.")
    }
    
    model_results <- model_results %>% dplyr::select(probe, contains(paste0(".", predictor, ".")))
    colnames(model_results) <- sub(paste0("\\.",predictor, "\\."), ".", colnames(model_results))
    # All residual dfs are the same (n-k-1)
    df_residual <- model_results$df_residual.1

    all_coefs <- model_results %>% dplyr::select(starts_with("coef"))
    all_SE <- model_results %>% dplyr::select(starts_with("SE_unscaled"))
    # Number of imputed datasets m
    m <- as.numeric(ncol(all_coefs))

    # Variance within is sum of square standard error divided by m number imputed datasets (m)
    # Calc variance within using unscaled SEs
    Vw <- apply(all_SE, 1, FUN = function(x) sum(x^2)) / m

    # pooled coefs, just the mean
    coefs_combined <- all_coefs %>% mutate(coef_pooled = rowMeans(all_coefs))
    # using pooled coefs we get variance between. subtract pooled coef from each imputed datasets coef
    coef_diff <- sweep(as.matrix(all_coefs), 1, as.matrix(coefs_combined$coef_pooled), "-")
    # get sum of squares of the pooled coef minus each imputed coef. Divide by m-1
    Vb <- apply(coef_diff, 1, FUN = function(x) sum(x^2)) / (m - 1)
    # Get total variance using using unscaled within variances
    Vtotal <- Vw + Vb + (Vb / m)

    # This is the Rubin's rules pooled SE
    SE_p <- sqrt(Vtotal)

    # Now get Rubin's rules degrees of freedom
    lambda <- (Vb + (Vb / m)) / Vtotal
    # RIV <- (Vb + (Vb/m))/Vw
    n <- as.numeric(ncol(DGE))
    DFold <- (m - 1) / (lambda^2)
    DFobs <- (((df_residual) + 1) / ((df_residual) + 3)) * (df_residual) * (1 - lambda)
    # The equation below is the residual degrees of freedom from voom and lmfit adjusted for rubins rules.
    df <- (DFold * DFobs) / (DFold + DFobs)
    if(is.nan(df[[1]])){ #if information lost (lambda) is 0,df will be nan
      df <- df_residual # in this case we use the original df unadjusted
    }
    #######################
    #######################
    ## eBayes part ########
    #######################
    #######################

    # Get all sigma values across imputed datasets
    all_sigma <- model_results %>% dplyr::select(starts_with("sigma"))
    # We can get std dev by dividing SE by sigma.
    all_std_dev <- all_SE / all_sigma


    # Now we get bayes prior df and bayes SE within each set of imputed datasets.
    # This way we get one set of priors rather than different prior per block of genes.
    priors <- foreach(i = seq(ncol(all_sigma)), .combine = "cbind") %do% {
        # Get sigma and std dev for ith imputed dataset
        sigma_i <- all_sigma[, i] %>% pull()
        std_dev_i <- all_std_dev[, i]

        # Get the priors!
        out <- squeezeVar(sigma_i^2, df_residual, covariate = covariate, robust = robust, winsor.tail.p = winsor.tail.p)
        s2.post <- out$var.post
        df_prior <- out$df.prior
        # Use s2.post with std dev to get bayes standard errors
        SE_bayes <- sqrt(s2.post) * std_dev_i
        SE_name <- paste0("SE_bayes.", i)
        df_name <- paste0("df_prior.", i)
        tibble(df_prior = df_prior, SE_bayes = SE_bayes) %>%
            dplyr::rename(
                !!SE_name := SE_bayes,
                !!df_name := df_prior
            )
    }
    # there is one prior df per set of imputed dataset. I am averaging them here. Each df_prior is
    # based on all genes being tested, but they come from different sets of imputed data.
    df_prior <- priors %>%
        dplyr::select(starts_with("df")) %>%
        rowMeans()
    df_prior <- df_prior[1]

    # Now apply rubins rules to the bayes standard errors
    all_SE_bayes <- priors %>% dplyr::select(starts_with("SE_bayes"))
    # Calc variance within using bayses SEs
    Vw_bayes <- apply(all_SE_bayes, 1, FUN = function(x) sum(x^2)) / m
    # Get total variance using using Bayes shrunk within variances
    Vtotal_bayes <- Vw_bayes + Vb + (Vb / m)
    # This is the Rubin's rules pooled bayses SE
    SE_p_bayes <- sqrt(Vtotal_bayes)

    # Bayes df. Replaces residual degrees of freedom with df.total, which is df.residual + df.prior.

    lambda_bayes <- (Vb + (Vb / m)) / Vtotal_bayes
    # RIV = (Vb + (Vb/m))/Vw
    n <- as.numeric(ncol(DGE))
    DFold <- (m - 1) / (lambda_bayes^2)
    DFobs <- (((df_residual + df_prior) + 1) / ((df_residual + df_prior) + 3)) * (df_residual + df_prior) * (1 - lambda_bayes)
    # The equation below is the residual degrees of freedom from voom and lmfit adjusted for rubins rules.
    df_bayes <- (DFold * DFobs) / (DFold + DFobs)
    if(is.nan(df_bayes[[1]])){ #if information lost (lambda) is 0,df will be nan
      df_bayes <- df_residual + df_prior # in this case we use the original df unadjusted
    }
    # Get the final results!
    rubins_t <- tibble(probe = model_results$probe, coef_combined = coefs_combined$coef_pooled, SE_p = SE_p, SE_p_bayes = SE_p_bayes, df = df, df_bayes = df_bayes) %>%
        mutate(
            rubins_t = coef_combined / SE_p,
            rubins_t_bayes = coef_combined / SE_p_bayes
        ) %>% # new t statistics
        mutate(
            combined_p = 2 * pt(-abs(rubins_t), df = df),
            combined_p_bayes = 2 * pt(-abs(rubins_t_bayes), df = df_bayes)
        ) %>% # get p values with t distribution two sided
        arrange(combined_p) %>% #
        mutate(
            combined_p_adj = p.adjust(combined_p, method = "fdr"),
            combined_p_adj_bayes = p.adjust(combined_p_bayes, method = "fdr")
        )
}

test_that("consistent results", {
    data(example_data)
    data(example_DGE)
    library(BiocParallel)
    intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
    gene_bin_impute <- impute_by_gene_bin(example_data,
        intervals,
        example_DGE,
        m = 2,
        BPPARAM = SerialParam(RNGseed = 2023)
    )
    coef_se <- limmavoom_imputed_data_list(
        gene_intervals = intervals,
        DGE = example_DGE,
        imputed_data_list = gene_bin_impute,
        m = 2,
        voom_formula = "~x + y + z + a + b",
        BPPARAM = SerialParam(RNGseed = 2023)
    )
    final_res <- combine_rubins(
        DGE = example_DGE,
        model_results = coef_se,
        predictor = "x"
    )
    expect_equal(final_res$coef_combined[1], -0.02099867, tolerance = 0.001)
})

#' combine_rubins_pca
#'
#' Combines results from each imputed dataset using Rubin's rules.
#' @return Coefficient, standard error, and p-value combined across m imputed datasets.
#' @param gene The number gene in the DGE list.
#' @param results_final List with one element per gene storing coefficients and standard errors from limma-voom analysis.
#' @param avg_df The average df.total from limma-voom analysis across the m imputed datasets.
#' @param m Number of imputed data sets.
#'
#' @importFrom stats pt
#' 
#' @keywords internal
combine_rubins_pca <- function(gene, results_final, avg_df, m) {
  # Extract coefficients and standard errors one gene at a time
  coef <- t(results_final[[gene]][seq(1, nrow(results_final[[gene]]), by = 2), ])
  se <- t(results_final[[gene]][seq(2, nrow(results_final[[gene]]), by = 2), ])
  # Variance within is sum of square standard error divided by m number imputed datasets (m)
  Vw <- apply(se, 1, FUN = function(x) sum(x^2)) / m
  # pooled coefs, just the mean
  coefs_combined <- rowMeans(coef)
  # using pooled coefs we get variance between. subtract pooled coef from each imputed datasets coef
  coef_diff <- sweep(coef, 1, coefs_combined, "-")
  # get sum of squares of the pooled coef minus each imputed coef. Divide by m-1
  Vb <- apply(coef_diff, 1, FUN = function(x) sum(x^2)) / (m - 1)
  # Get total variance using using unscaled within variances
  Vtotal <- Vw + Vb + (Vb / m)
  # This is the Rubin's rules pooled SE, the sqrt of total variance
  SE_p <- sqrt(Vtotal)
  # Now get Rubin's rules degrees of freedom adjusted (Barnard and Rubin 1999)
  lambda <- (Vb + (Vb / m)) / Vtotal
  # RIV <- (Vb + (Vb/m))/Vw
  DFold <- (m - 1) / (lambda^2)
  #avg_df is n-k-1 then bayes moderated then averaged across imputations
  DFobs <- (((avg_df) + 1) / ((avg_df) + 3)) * (avg_df+1) * (1 - lambda)
  # The degrees of freedom from voom and lmfit adjusted for rubins rules.
  df <- (DFold * DFobs) / (DFold + DFobs)
  if(is.nan(df[[1]])){ #if information lost (lambda) is 0,df will be nan
    df <-avg_df # in this case we use the original df unadjusted
  }
  # Calculate Rubin's t statistic
  rubins_t_bayes <- coefs_combined / SE_p
  # Calculate combined p-value and return results
  combined_p_bayes <- as.data.frame(t(2 * pt(-abs(rubins_t_bayes), df = df)))
  colnames(combined_p_bayes) <- paste0(colnames(combined_p_bayes), "_p")
  coefs_combined <- as.data.frame(t(coefs_combined))
  colnames(coefs_combined) <- paste0(colnames(coefs_combined), "_coef")
  SE_p <- as.data.frame(t(SE_p))
  colnames(SE_p) <- paste0(colnames(SE_p), "_se")
  return(cbind(combined_p_bayes, coefs_combined, SE_p))
}

#' lowess_all_gene_bins
#'
#' Loops through all bins and all M imputations, prepares DGE and design to run
#' voom_sx_sy, which fits gene-wise linear models and extracts log count size (sx)
#' and sqrt resudual standard deviations (sy) to make the lowess curve
#' @return All sx and sy values for lowess function across all M imputations.
#'
#' @include voom_sx_sy.R
#'
#' @keywords internal
lowess_all_gene_bins <- function(gene_intervals, DGE, imputed_data_list, m, voom_formula) {
    lowess_all_gene_bins <- foreach(i = seq(m), .combine = "rbind") %do% {
        foreach(gene_bin = seq(length(imputed_data_list)), .combine = "rbind") %do% {
            # Get imputed data for this gene bin and this M imputed dataset
            imputed_data <- complete(imputed_data_list[[gene_bin]], i)
            # Get DGE list for this gene interval
            alldg_bin <- DGE[as.numeric(gene_intervals[gene_bin, 1]):as.numeric(gene_intervals[gene_bin, 2]), ]
            design1 <- model.matrix(as.formula(voom_formula), imputed_data)
            # voom_sx_sy is the first half of the voom function to get sx and sy for lowess curve
            out <- voom_sx_sy(alldg_bin, design1, lib.size.all = DGE$samples$lib.size * DGE$samples$norm.factors)
        }
    }
}

## ----eval=FALSE---------------------------------------------------------------
# # Install from github
# library(devtools)
# install_github("brennanhilton/RNAseqCovarImpute")
# 
# # Install from Bioconductor (not yet on Bioconductor)
# 
# if (!require("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# 
# BiocManager::install("RNAseqCovarImpute")

## -----------------------------------------------------------------------------
library(RNAseqCovarImpute)
library(dplyr)
library(BiocParallel)
library(PCAtools)
library(limma)
library(mice)
data(example_data)
data(example_DGE)

## -----------------------------------------------------------------------------
# We use voom to convert counts to logCPM values, adding 0.5 to all the counts to avoid taking the logarithm of zero, and normalized for library size.
start.pca = Sys.time() # To calculate runtime
pca_data = limma::voom(example_DGE)$E
# Conduct pca
p = PCAtools::pca(pca_data)
# Determine the number of PCs that account for >80% explained variation
which(cumsum(p$variance) > 80)[1]
# Extract the PCs and append to our data
pcs = p$rotated[,1:78]
example_data = cbind(example_data, pcs)

## -----------------------------------------------------------------------------
# Conduct mice. In practice, m should be much larger (e.g., 10-100)
imp = mice::mice(example_data, m=3)

## -----------------------------------------------------------------------------
mi_pca_res = RNAseqCovarImpute::limmavoom_imputed_data_pca(imp = imp,
                                                           DGE = example_DGE,
                                                           voom_formula = "~x + y + z + a + b",
                                                           BPPARAM = SerialParam())

# Display the results for the first 5 genes for the x variable in the model.
mi_pca_res[1:5, grep("^x", colnames(mi_pca_res))]

## -----------------------------------------------------------------------------
mi_pca_res_x = mi_pca_res %>% 
  arrange(x_p) %>% 
  mutate(x_p_adj = p.adjust(x_p, method = "fdr")) %>% 
  dplyr::select(probe, x_coef, x_p, x_p_adj)

end.pca = Sys.time() # To calculate runtime
time.pca = end.pca - start.pca # To calculate runtime
# Display the results for the first 5 genes
mi_pca_res_x[1:5,]

## -----------------------------------------------------------------------------
# Get back the original example_data without the PCs appended
data(example_data)
start.old.method = Sys.time() # To calculate runtime
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)

## ----message=FALSE, warning=FALSE, echo=FALSE---------------------------------
intervals %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The first 10 gene bins. Start and end columns indicate row numbers for the beginning and end of each bin. Number indicates the number of genes in each bin.")

## -----------------------------------------------------------------------------
# Randomize the order of gene identifiers
annot <- example_DGE$genes
annot <- annot[sample(seq_len(nrow(annot))), ]
# Match order of the genes in the DGE to the randomized order of genes in the annotation
example_DGE <- example_DGE[annot, ]

## -----------------------------------------------------------------------------
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3
)

## -----------------------------------------------------------------------------
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3,
    BPPARAM = SerialParam()
)

## -----------------------------------------------------------------------------
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 3,
    voom_formula = "~x + y + z + a + b"
)

## -----------------------------------------------------------------------------
final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)

end.old.method = Sys.time() # To calculate runtime
time.old.method = end.old.method - start.old.method

## ----message=FALSE, warning=FALSE, echo=FALSE---------------------------------
final_res %>%
    dplyr::select(probe, coef_combined, combined_p_bayes, combined_p_adj_bayes) %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The top 10 genes associated with predictor x sorted by lowest P-value")

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' limmavoom_imputed_data_pca
#'
#' Combines results from each imputed dataset using Rubin's rules.
#' @return Dataframe with one row per gene. Columns contain coefficients, standard errors, and p-values from the limma-voom pipeline.
#' @param imp Imputed data from mice (mids object)
#' @param DGE A DGEList object.
#' @param voom_formula Formula for design matrix.
#' @param BPPARAM A BiocParallelParam object
#' 
#' @include limmavoom_imputed_data_pca_helper.R
#' @include combine_rubins_pca.R
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate select everything
#' @importFrom BiocParallel bpparam bplapply
#' @importFrom BiocGenerics Reduce
#' 
#' @examples
#' data(example_data)
#' data(example_DGE)
#' pca_data = limma::voom(example_DGE)$E
#' p = PCAtools::pca(pca_data)
#' pcs = p$rotated[,1:78]
#' example_data = cbind(example_data, pcs)
#' imp = mice::mice(example_data, m=3)
#' mi_pca_res = limmavoom_imputed_data_pca(
#'    imp = imp,
#'    DGE = example_DGE,
#'    voom_formula = "~x + y + z + a + b"
#'    )
#' @export
limmavoom_imputed_data_pca <- function(imp, DGE, voom_formula, BPPARAM = bpparam()) {
  results <- BiocParallel::bplapply(seq(1, imp$m),
                      FUN = limmavoom_imputed_data_pca_helper,
                      BPPARAM = BPPARAM,
                      imp=imp,
                      DGE=DGE,
                      voom_formula= voom_formula)
  
  results_final <- BiocParallel::bplapply(seq_len(nrow(DGE)),
                            BPPARAM = BPPARAM,
                            FUN = function(gene) {
                              BiocParallel::bplapply(seq_along(results),
                                       BPPARAM = BiocParallel::bpparam("SerialParam"),
                                       FUN = function(imp_data) {
                                         res <- rbind(results[[imp_data]]$coef[gene, ], results[[imp_data]]$SE[gene, ])
                                         rownames(res) <- c("coef", "SE")
                                         res
                                         })
                              })
  
  results_final <- lapply(results_final, function(x) {
    do.call(rbind, x)
  })
  
  dfs <- lapply(results, function(inner_list) inner_list$df)
  avg_df = BiocGenerics::Reduce(`+`, dfs) / length(dfs)
  
  final_res_pca <- 
    do.call(rbind,
            BiocParallel::bplapply(
              seq_along(results_final),
              FUN = combine_rubins_pca,
              results_final = results_final,
              avg_df = avg_df,
              m = imp$m,
              BPPARAM = BPPARAM))
  final_res_pca <- as.data.frame(final_res_pca) %>% 
    mutate(probe = rownames(DGE)) %>% 
    dplyr::select(probe, dplyr::everything())
}

#' get_gene_bin_intervals
#'
#' Creates gene bins. Input DGE list, sample data,
#' and 'n' number of individuals per genes. By default, number of bins and
#' genes per bin are set so that each bin has approximately 1 gene per
#' 10 individuals in the data.
#' @return Data frame with one row per gene bin. Columns indicate the start and end positions and the number of genes of each bin.
#' @param DGE A DGEList object.
#' @param data Sample data with one row per sample. Sample row order should match the col order in the DGEList.
#' @param n Genes per bin are set so that each bin has approximately 1 gene per n individuals in the data.
#' @importFrom rlang .data
#'
#' @examples
#' data(example_data)
#' data(example_DGE)
#' intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
#' gene_bin_impute <- impute_by_gene_bin(example_data,
#'     intervals,
#'     example_DGE,
#'     m = 2
#' )
#' coef_se <- limmavoom_imputed_data_list(
#'     gene_intervals = intervals,
#'     DGE = example_DGE,
#'     imputed_data_list = gene_bin_impute,
#'     m = 2,
#'     voom_formula = "~x + y + z + a + b"
#' )
#'
#' final_res <- combine_rubins(
#'     DGE = example_DGE,
#'     model_results = coef_se,
#'     predictor = "x"
#' )
#' @export

get_gene_bin_intervals <- function(DGE, data, n = 10) {
    # Validity tests
    if (!class(DGE) %in% "DGEList") {
        stop("Input 'DGE' is not a valid DGEList object.")
    }
    if (!any((class(data) %in% c("tbl_df", "tbl", "data.frame")))) {
        stop("Input 'data' is not a valid data.frame, tbl, or tbl_df object.")
    }
    if (!(class(n) %in% c("numeric"))) {
        stop("Input 'n' must be numeric.")
    }

    gene_number <- as.numeric(nrow(DGE))
    genes_per_bin <- floor(nrow(data)/n)
    num_bins <- floor(gene_number/genes_per_bin)
    remainder = gene_number - (genes_per_bin*num_bins)
    
    # Initialize the bins with the lowest possible genes_per_bin
    bins <- rep(genes_per_bin, num_bins)
    
    # Distribute the remainder evenly across the bins
    i <- 1
    while (remainder > 0) {
        bins[i] <- bins[i] + 1
        remainder <- remainder - 1
        i <- i %% num_bins + 1 #bump i to the next bin, can also go back to bin 1
    }
  
    # Calculate the start and end genes for each bin
    start_genes <- c(1, cumsum(bins[-num_bins]) + 1)
    end_genes <- cumsum(bins)
    output <- data.frame(start = start_genes, end = end_genes, number = bins)
}

test_that("Intervals correct type", {
    data(example_data)
    data(example_DGE)
    intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
    expect_type(intervals, "list")
})

test_that("Intervals includes all rows in data", {
    data(example_data)
    data(example_DGE)
    intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
    expect_equal(nrow(example_data), sum(intervals$number))
})

test_that("impute_by_gene_bin outputs mids", {
    data(example_data)
    data(example_DGE)
    intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
    gene_bin_impute <- impute_by_gene_bin(example_data,
        intervals,
        example_DGE,
        m = 2
    )
    expect_s3_class(gene_bin_impute[[1]], "mids")
})

#' limmavoom_imputed_data_list_helper
#'
#' Loops through the imputed data list (output from "impute_by_gene_bin" function)
#' and runs limma-voom RNA seq analysis.
#' @return A dataframe with coefficient, standard error, sigma, and residual degrees of freedom values from limma-voom gene expression analysis. One row per gene and one set of values per imputed dataset.
#' @param gene_intervals Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.
#' @param DGE A DGEList object.
#' @param imputed_data_list Output from impute_by_gene_bin.
#' @param m Number of imputed data sets.
#' @param voom_formula Formula for design matrix.
#'
#' @include voom_master_lowess.R
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate bind_cols as_tibble left_join pull
#' @importFrom foreach %do% foreach
#' @importFrom edgeR cpm
#' @importFrom mice mice quickpred complete
#' @importFrom stats model.matrix
#' @importFrom rlang .data
#' @importFrom limma normalizeBetweenArrays lmFit
#'
#' @keywords internal
limmavoom_imputed_data_list_helper <- function(gene_bin, gene_intervals, DGE, imputed_data_list, m, voom_formula, sx_sy) {
    # get mean-variance curve from all genes across all M imputations

    # get imputed data
    imputed_data <- imputed_data_list[[gene_bin]]
    # get dge list for this gene interval
    alldg_bin <- DGE[as.numeric(gene_intervals[gene_bin, 1]):as.numeric(gene_intervals[gene_bin, 2]), ]

    all_coef_se_within_bin <- foreach(i = seq(m), .combine = "left_join") %do% {
        # we have imputed data for a particular gene bin interval.
        # now we get the ith imputed data set within
        data_i <- complete(imputed_data, i)

        # run limmavoom
        design1 <- model.matrix(as.formula(voom_formula), data_i)

        voom1 <- voom_master_lowess(alldg_bin, design1, lib.size.all = DGE$samples$lib.size * DGE$samples$norm.factors, sx = sx_sy$sx, sy = sx_sy$sy)
        fit1 <- lmFit(voom1)

        # get coefficients unscaled SE, df residual, and sigma from fit1
        coef <- fit1$coefficients %>% as_tibble()
        SE_unscaled <- fit1$stdev.unscaled * fit1$sigma
        SE_unscaled <- as_tibble(SE_unscaled)
        degrees_freedom_residual <- fit1$df.residual
        sigma <- fit1$sigma

        output1 = foreach(lm_predictor = seq(coef), .combine = "left_join") %do% {
          res = tibble(probe = rownames(fit1),
                       coef = pull(coef[lm_predictor]),
                       SE_unscaled = pull(SE_unscaled[lm_predictor]),
                       sigma = sigma,
                       df_residual = degrees_freedom_residual)
          # rename fit values to include info on which imputed data they come from and which contrast from model
          colnames(res)[colnames(res) != "probe"] <- paste0(colnames(res)[colnames(res) != "probe"], ".", colnames(coef[lm_predictor]), ".", i)
          res
        }
        output1
    }
    return(all_coef_se_within_bin)
}

#' impute_by_gene_bin_helper
#'
#' Loops through DGE list using the gene bin intervals from the
#' "get_gene_bin_intervals" function and makes imputed datasets. For instance,
#' if n = 100 and intervals contains 200 gene bin intervals, output will be a list of
#' 200 sets of 100 imputed datasets. Each of the 200 sets are imputed
#' using only the genes in one gene bin.
#' @return A list of sets of n imputed datasets, one per gene bin.
#' @param data Sample data with one row per sample. Sample row order should match the col order in the DGEList.
#' @param intervals Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.
#' @param DGE A DGEList object.
#' @param m Number of imputed data sets.
#' @param maxit Used by mice function.
#' @param param Arguments passed to BiocParallel::bpparam()
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate bind_cols as_tibble
#' @importFrom foreach %do% foreach
#' @importFrom edgeR cpm
#' @importFrom mice mice quickpred
#' @importFrom rlang .data
#'
#' @keywords internal
# Define a function for imputation that will be called by bplapply
impute_gene_bin_helper <- function(i, intervals, cpm_all, data, m, maxit) {
    # Extract cpm for the current bin of genes based on the interval
    cpm_bin <- cpm_all[as.numeric(intervals[i, 1]):as.numeric(intervals[i, 2]), ] %>%
        t() %>%
        as_tibble()

    # Add the bin of genes to the covariate data
    data_mice <- data %>% bind_cols(cpm_bin)

    # Impute the data using mice
    imputed_data <- mice(data_mice, m = m, maxit = maxit, predictorMatrix = quickpred(data_mice))

    return(imputed_data)
}

#' voom_sx_sy
#'
#' Modified voom function used by limma_voom-imputed_data_list function.
#' Allows input of bins of outcome genes while still accounting for the total library size
#' of all outcome genes, as the total library size is needed to calculate log-cpm values.
#' Returns just the sx and sy values needed for lowess curve. Adapted from limma::voom.
#' Code from limma covered by License: GPL (>=2)
#' @return Tibble with one col for sx and one for sy for lowess function.
#'
#' @keywords internal
voom_sx_sy <- function(counts, design=NULL, lib.size=NULL, normalize.method="none", block=NULL, correlation=NULL, weights=NULL, span=0.5, plot=FALSE, save.plot=FALSE, lib.size.all)
    # 	Linear modelling of count data with mean-variance modelling at the observation level.
    # 	Creates an EList object for entry to lmFit() etc in the limma pipeline.
    # 	Gordon Smyth and Charity Law
# 	Created 22 June 2011.  Last modified 1 May 2021.
{
    out <- list()

    # 	Extract counts from known data objects
    if (is(counts, "DGEList")) {
        out$genes <- counts$genes
        out$targets <- counts$samples
        if (is.null(design) && diff(range(as.numeric(counts$sample$group))) > 0) design <- model.matrix(~group, data = counts$samples)
        if (is.null(lib.size)) lib.size <- counts$samples$lib.size * counts$samples$norm.factors
        counts <- counts$counts
    } else {
        isExpressionSet <- suppressPackageStartupMessages(is(counts, "ExpressionSet"))
        if (isExpressionSet) {
            if (length(Biobase::fData(counts))) out$genes <- Biobase::fData(counts)
            if (length(Biobase::pData(counts))) out$targets <- Biobase::pData(counts)
            counts <- Biobase::exprs(counts)
        } else {
            counts <- as.matrix(counts)
        }
    }

    # 	Check counts
    n <- nrow(counts)
    if (n < 2L) stop("Need at least two genes to fit a mean-variance trend")
    m <- min(counts)
    if (is.na(m)) stop("NA counts not allowed")
    if (m < 0) stop("Negative counts not allowed")

    # 	Check design
    if (is.null(design)) {
        design <- matrix(1, ncol(counts), 1)
        rownames(design) <- colnames(counts)
        colnames(design) <- "GrandMean"
    }

    # 	Check lib.size
    if (is.null(lib.size)) lib.size <- colSums(counts)

    # 	Fit linear model to log2-counts-per-million
    y <- t(log2(t(counts + 0.5) / (lib.size + 1) * 1e6))
    y <- normalizeBetweenArrays(y, method = normalize.method)
    fit <- lmFit(y, design, block = block, correlation = correlation, weights = weights)
    if (is.null(fit$Amean)) fit$Amean <- rowMeans(y, na.rm = TRUE)

    # 	If no replication found, set all weight to 1
    NWithReps <- sum(fit$df.residual > 0L)
    if (NWithReps < 2L) {
        if (NWithReps == 0L) warning("The experimental design has no replication. Setting weights to 1.")
        if (NWithReps == 1L) warning("Only one gene with any replication. Setting weights to 1.")
        out$E <- y
        out$weights <- y
        out$weights[] <- 1
        out$design <- design
        if (is.null(out$targets)) {
            out$targets <- data.frame(lib.size = lib.size)
        } else {
            out$targets$lib.size <- lib.size
        }
        return(new("EList", out))
    }

    # 	Fit lowess trend to sqrt-standard-deviations by log-count-size
    sx <- fit$Amean + mean(log2(lib.size.all + 1)) - log2(1e6)
    sy <- sqrt(fit$sigma)
    allzero <- rowSums(counts) == 0
    if (any(allzero)) {
        sx <- sx[!allzero]
        sy <- sy[!allzero]
    }
    out_sx_sy <- tibble(sx = sx, sy = sy)
}

#' voom_master_lowess
#'
#' Modified voom function used by limma_voom-imputed_data_list function.
#' Allows input of bins of outcome genes while still accounting for the total library size
#' of all outcome genes, as the total library size is needed to calculate log-cpm values.
#' Also allows use of external sx and sy to create lowess curve. Here, sx and sy should
#' come from all gene bins across all M imputations. Adapted from limma::voom.
#' Code from limma covered by License: GPL (>=2)
#' @return Same as limma::voom.
#'
#' @keywords internal
voom_master_lowess <- function(counts, design=NULL, lib.size=NULL, normalize.method="none", block=NULL, correlation=NULL, weights=NULL, span=0.5, plot=FALSE, save.plot=FALSE, lib.size.all, sx, sy)
    # 	Linear modelling of count data with mean-variance modelling at the observation level.
    # 	Creates an EList object for entry to lmFit() etc in the limma pipeline.
    # 	Gordon Smyth and Charity Law
# 	Created 22 June 2011.  Last modified 1 May 2021.
{
    out <- list()

    # 	Extract counts from known data objects
    if (is(counts, "DGEList")) {
        out$genes <- counts$genes
        out$targets <- counts$samples
        if (is.null(design) && diff(range(as.numeric(counts$sample$group))) > 0) design <- model.matrix(~group, data = counts$samples)
        if (is.null(lib.size)) lib.size <- counts$samples$lib.size * counts$samples$norm.factors
        counts <- counts$counts
    } else {
        isExpressionSet <- suppressPackageStartupMessages(is(counts, "ExpressionSet"))
        if (isExpressionSet) {
            if (length(Biobase::fData(counts))) out$genes <- Biobase::fData(counts)
            if (length(Biobase::pData(counts))) out$targets <- Biobase::pData(counts)
            counts <- Biobase::exprs(counts)
        } else {
            counts <- as.matrix(counts)
        }
    }

    # 	Check counts
    n <- nrow(counts)
    if (n < 2L) stop("Need at least two genes to fit a mean-variance trend")
    m <- min(counts)
    if (is.na(m)) stop("NA counts not allowed")
    if (m < 0) stop("Negative counts not allowed")

    # 	Check design
    if (is.null(design)) {
        design <- matrix(1, ncol(counts), 1)
        rownames(design) <- colnames(counts)
        colnames(design) <- "GrandMean"
    }

    # 	Check lib.size
    if (is.null(lib.size)) lib.size <- colSums(counts)

    # 	Fit linear model to log2-counts-per-million
    y <- t(log2(t(counts + 0.5) / (lib.size + 1) * 1e6))
    y <- normalizeBetweenArrays(y, method = normalize.method)
    fit <- lmFit(y, design, block = block, correlation = correlation, weights = weights)
    if (is.null(fit$Amean)) fit$Amean <- rowMeans(y, na.rm = TRUE)

    # 	If no replication found, set all weight to 1
    NWithReps <- sum(fit$df.residual > 0L)
    if (NWithReps < 2L) {
        if (NWithReps == 0L) warning("The experimental design has no replication. Setting weights to 1.")
        if (NWithReps == 1L) warning("Only one gene with any replication. Setting weights to 1.")
        out$E <- y
        out$weights <- y
        out$weights[] <- 1
        out$design <- design
        if (is.null(out$targets)) {
            out$targets <- data.frame(lib.size = lib.size)
        } else {
            out$targets$lib.size <- lib.size
        }
        return(new("EList", out))
    }

    # 	Fit lowess trend to sqrt-standard-deviations by log-count-size
    # sx and sy come from all gene bins, then curve is applied to just the gene bin being worked on

    l <- lowess(sx, sy, f = span)

    # 	Make interpolating rule
    # 	Special treatment of zero counts is now removed;
    # 	instead zero counts get same variance as smallest gene average.
    # 	l$x <- c(0.5^0.25, l$x)
    # 	l$x <- c(log2(0.5), l$x)
    # 	var0 <- var(log2(0.5*1e6/(lib.size+0.5)))^0.25
    # 	var0 <- max(var0,1e-6)
    # 	l$y <- c(var0, l$y)
    f <- approxfun(l, rule = 2, ties = list("ordered", mean))

    # 	Find individual quarter-root fitted counts
    if (fit$rank < ncol(design)) {
        j <- fit$pivot[1:fit$rank]
        fitted.values <- fit$coefficients[, j, drop = FALSE] %*% t(fit$design[, j, drop = FALSE])
    } else {
        fitted.values <- fit$coefficients %*% t(fit$design)
    }
    fitted.cpm <- 2^fitted.values
    fitted.count <- 1e-6 * t(t(fitted.cpm) * (lib.size + 1))
    fitted.logcount <- log2(fitted.count)

    # 	Apply trend to individual observations
    w <- 1 / f(fitted.logcount)^4
    dim(w) <- dim(fitted.logcount)

    # 	Output
    out$E <- y
    out$weights <- w
    out$design <- design
    if (is.null(out$targets)) {
        out$targets <- data.frame(lib.size = lib.size)
    } else {
        out$targets$lib.size <- lib.size
    }
    if (save.plot) {
        out$voom.xy <- list(x = sx, y = sy, xlab = "log2( count size + 0.5 )", ylab = "Sqrt( standard deviation )")
        out$voom.line <- l
    }

    new("EList", out)
}

#' Simulated counts in DGE list
#'
#' The exact code used to generate these data are found in the Example_Data_for_RNAseqCovarImpute
#' vignette. In short, `example_data` contains 500 rows with data for variables x, y, and z, which
#' are continuous normally distributed, and a and b, which are binary variables. Missigness
#' was simulated for all variables other than x such that a complete case analysis would drop
#' 24.2% of participants. `example_DGE` contains random count data from the Poisson distribution
#' for 500 made up genes, ENS1-ENS500
#'
#' @format ## `example_DGE`
#' A DGElist with 500 genes and 500 samples
#'
#' @return DGElist for 500 made up genes, ENS1-ENS500
#' @docType data
#' @keywords datasets
#' @name example_DGE
#' @usage data(example_DGE)
#' @examples
#' data(example_DGE)
"example_DGE"

#' limmavoom_imputed_data_list
#'
#' Loops through the imputed data list (output from "impute_by_gene_bin" function)
#' and runs limma-voom RNA seq analysis.
#' @return A dataframe with coefficient, standard error, sigma, and residual degrees of freedom values from limma-voom gene expression analysis. One row per gene and one set of values per imputed dataset.
#' @param gene_intervals Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.
#' @param DGE A DGEList object.
#' @param imputed_data_list Output from impute_by_gene_bin.
#' @param m Number of imputed data sets.
#' @param voom_formula Formula for design matrix.
#' @param BPPARAM A BiocParallelParam object
#'
#' @include limmavoom_imputed_data_list_helper.R
#' @include lowess_all_gene_bins.R
#' @importFrom BiocParallel bpparam bplapply
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate select rename as_tibble all_of bind_cols as_tibble pull
#' @importFrom foreach %do% foreach
#' @importFrom edgeR cpm
#' @importFrom mice complete
#' @importFrom stats model.matrix as.formula
#' @importFrom limma lmFit normalizeBetweenArrays
#' @importFrom rlang .data
#' @importFrom dplyr left_join
#'
#' @examples
#' data(example_data)
#' data(example_DGE)
#' intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
#' gene_bin_impute <- impute_by_gene_bin(example_data,
#'     intervals,
#'     example_DGE,
#'     m = 2
#' )
#' coef_se <- limmavoom_imputed_data_list(
#'     gene_intervals = intervals,
#'     DGE = example_DGE,
#'     imputed_data_list = gene_bin_impute,
#'     m = 2,
#'     voom_formula = "~x + y + z + a + b"
#' )
#'
#' final_res <- combine_rubins(
#'     DGE = example_DGE,
#'     model_results = coef_se,
#'     predictor = "x"
#' )
#' @export


limmavoom_imputed_data_list <- function(gene_intervals, DGE, imputed_data_list, m, voom_formula, BPPARAM = bpparam()) {
    # Validity tests
    if (!class(DGE) %in% "DGEList") {
        stop("Input 'DGE' is not a valid DGEList object.")
    }
    if (!(class(m) %in% c("numeric"))) {
        stop("Input 'm' must be numeric.")
    }
    if (!class(as.formula(voom_formula)) %in% c("formula")) {
        stop()
    }

    # Get mean-variance curve from all genes across all M imputations
    sx_sy <- lowess_all_gene_bins(gene_intervals, DGE, imputed_data_list, m, voom_formula)

    # Parallelize the loop using bplapply
    all_coefs_se <- bplapply(seq(length(imputed_data_list)),
        gene_intervals = gene_intervals,
        m = m,
        imputed_data = imputed_data_list,
        DGE = DGE,
        voom_formula = voom_formula,
        sx_sy = sx_sy,
        FUN = limmavoom_imputed_data_list_helper,
        BPPARAM = BPPARAM
    )

    all_coefs_se <- do.call(rbind, all_coefs_se)
    return(all_coefs_se)
}

#' impute_by_gene_bin
#'
#' Loops through DGE list using the gene bin intervals from the
#' "get_gene_bin_intervals" function and makes imputed datasets. For instance,
#' if n = 100 and intervals contains 200 gene bin intervals, output will be a list of
#' 200 sets of 100 imputed datasets. Each of the 200 sets are imputed
#' using only the genes in one gene bin.
#' @return A list of sets of n imputed datasets, one per gene bin.
#' @param data Sample data with one row per sample. Sample row order should match the col order in the DGEList.
#' @param intervals Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.
#' @param DGE A DGEList object.
#' @param m Number of imputed data sets.
#' @param maxit Used by mice function.
#' @param BPPARAM A BiocParallelParam object
#'
#' @include impute_by_gene_bin_helper.R
#' @importFrom BiocParallel bpparam bplapply
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate bind_cols as_tibble
#' @importFrom foreach %do% foreach
#' @importFrom edgeR cpm
#' @importFrom mice mice quickpred
#' @importFrom rlang .data
#'
#' @examples
#' data(example_data)
#' data(example_DGE)
#' intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
#' gene_bin_impute <- impute_by_gene_bin(example_data,
#'     intervals,
#'     example_DGE,
#'     m = 2
#' )
#' coef_se <- limmavoom_imputed_data_list(
#'     gene_intervals = intervals,
#'     DGE = example_DGE,
#'     imputed_data_list = gene_bin_impute,
#'     m = 2,
#'     voom_formula = "~x + y + z + a + b"
#' )
#'
#' final_res <- combine_rubins(
#'     DGE = example_DGE,
#'     model_results = coef_se,
#'     predictor = "x"
#' )
#' @export


# Define the function to perform parallel imputation using bplapply
impute_by_gene_bin <- function(data, intervals, DGE, m, maxit = 10, BPPARAM = bpparam()) {
    # Validity tests
    if (!class(DGE) %in% "DGEList") {
        stop("Input 'DGE' is not a valid DGEList object.")
    }
    if (!any((class(data) %in% c("tbl_df", "tbl", "data.frame")))) {
        stop("Input 'data' is not a valid data.frame, tbl, or tbl_df object.")
    }
    if (!(class(m) %in% c("numeric"))) {
        stop("Input 'm' must be numeric.")
    }
    if (!(class(maxit) %in% c("numeric"))) {
        stop("Input 'maxit' must be numeric.")
    }
    # get the counts per million for all genes in DGE
    cpm_all <- cpm(DGE, log = TRUE, prior.count = 5)

    gene_bin_impute <- bplapply(seq(nrow(intervals)),
        intervals = intervals,
        cpm_all = cpm_all,
        data = data,
        m = m,
        maxit = maxit,
        FUN = impute_gene_bin_helper,
        BPPARAM = BPPARAM
    )

    return(gene_bin_impute)
}

---
title: "Example Data for RNAseqCovarImpute"
author:
- name: Brennan H Baker
  affiliation: University of Washington
  email: brennanhilton@gmail.com
package: RNAseqCovarImpute
output:
  BiocStyle::html_document
vignette: |
  %\VignetteIndexEntry{Example Data for RNAseqCovarImpute}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---


# Generate random data

Normally you would have your own covariate and RNA-sequencing data. We generate random data below for the purpose of demonstrating how the functions in the RNAseqCovarImpute package work.
```{r, message=FALSE, warning=FALSE, eval = requireNamespace(c("stringr", "tidyr"))}
library(dplyr)
library(stringr)
library(tidyr)
library(edgeR)
library(mice)
# Generate random covariate data
set.seed(2023)
x1 <- rnorm(n = 500)
y1 <- rnorm(n = 500)
z1 <- rnorm(n = 500)
a1 <- rbinom(n = 500, prob = .25, size = 1)
b1 <- rbinom(n = 500, prob = .5, size = 1)
data <- data.frame(x = x1, y = y1, z = z1, a = a1, b = b1)

# Generate random count data from Poisson distribution
nsamp <- nrow(data)
ngene <- 500
mat <- matrix(stats::rpois(n = nsamp * ngene, lambda = sample(1:500, ngene, replace = TRUE)),
    nrow = ngene,
    ncol = nsamp
)

# Make fake ENSEMBL gene numbers
annot <- tibble(number = seq_len(ngene), name1 = "ENS") %>%
    mutate(ENSEMBL = str_c(name1, number)) %>%
    dplyr::select(ENSEMBL)
rownames(mat) <- annot$ENSEMBL

# Make DGE list and set rownames to ENSEMBL gene numbers above
example_DGE <- DGEList(mat, genes = annot)
rownames(example_DGE) <- annot$ENSEMBL
```

# Simulate missingness in the random data
Now we simulate missingness in the random data generated above using the mice ampute function. The below code simulates missingness in the data for all but the first variable (x), which we consider the main predictor of interest in this example. See the ampute documentation for more details. 
```{r, message=FALSE, warning=FALSE}
# First get all combos of 0 or 1 for the 4 other variables (y, z, a, and b)
pattern_vars <- expand.grid(c(0, 1), c(0, 1), c(0, 1), c(0, 1))
# Then add back a column for the predictor of interest, which is never amputed, so the first col =1 the whole way down
pattern2 <- matrix(1, nrow = nrow(pattern_vars), ncol = 1)
pattern1 <- cbind(pattern2, pattern_vars)
# Remove last row which is all 1s (all 1s means no missingness induced)
pattern <- pattern1[seq_len(15), ]

# Specify proportion of missing data and missingness mechanism for the ampute function
prop_miss <- 25
miss_mech <- "MAR"
result <- ampute(data = data, prop = prop_miss, mech = miss_mech, patterns = pattern)

# Extract the missing data
example_data <- result$amp
# Ampute function turns factors to numeric, so convert back to factors
example_data <- example_data %>% mutate(
    a = as.factor(a),
    b = as.factor(b)
)

# Calculate the new sample size if NAs are dropped as in a complete case analysis
sample_size <- example_data %>%
    drop_na() %>%
    nrow()

# As shown below, we have 24.2% missingness.
100 * (nsamp - sample_size) / nsamp
```


```{r, message=FALSE, warning=FALSE, echo=FALSE}
example_data %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The first 10 rows of simulated covariate data with missingness")
```

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

---
title: "Impute Covariate Data in RNA-sequencing Studies"
author:
- name: Brennan H Baker
  affiliation: University of Washington
  email: brennanhilton@gmail.com
package: RNAseqCovarImpute
output:
  BiocStyle::html_document
vignette: |
  %\VignetteIndexEntry{Impute Covariate Data in RNA-sequencing Studies}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

# Introduction

The RNAseqCovarImpute package makes linear model analysis for RNA-seq read counts compatible with multiple imputation (MI) of missing covariates. Relying on the Bioconductor `limma` package, RNAseqCovarImpute is included in Bioconductor as an extension of the [variance modeling at the observational level (voom) method](https://doi.org/10.1186/gb-2014-15-2-r29) which can be applied in circumstances with missing covariate data.

Missing data is a common problem in observational studies, as modeling techniques such as linear regression cannot be fit to data with missing points. Missing data is frequently handled using complete case analyses in which any individuals with missing data are dropped from the study. Dropping participants can reduce statistical power and, in some cases, result in biased model estimates. A common technique to address these problems is to replace or ‘impute’ missing data points with substituted values. Typically, for a given covariate, missing data points are imputed using a prediction model including other relevant covariates as independent variables. In single imputation, a missing value is replaced with the most likely value based on the predictive model. However, by ignoring the uncertainty inherent with predicting missing data, single imputation methods can result in biased coefficients and over-confident standard errors. MI addresses this problem by generating several predictions, thereby allowing for uncertainty about the missing data. In a typical MI procedure: 1) M imputed data sets are created, 2) each data set is analyzed separately (e.g., using linear regression), and 3) estimates and standard errors across the M analyses are pooled using Rubin’s rules. A major problem with implementing MI in RNA sequencing studies is that the outcome data must be included in the imputation prediction models to avoid bias. This is difficult in omics studies with high-dimensional data. 

The first method we developed in the RNAseqCovarImpute package surmounts the problem of high-dimensional outcome data by binning genes into smaller groups to analyze pseudo-independently. This method implements covariate MI in gene expression studies by 1) randomly binning genes into smaller groups, 2) creating M imputed datasets separately within each bin, where the imputation predictor matrix includes all covariates and the log counts per million (CPM) for the genes within each bin, 3) estimating gene expression changes using `limma::voom` followed by `limma::lmFit` functions, separately on each M imputed dataset within each gene bin, 4) un-binning the gene sets and stacking the M sets of model results before applying the `limma::squeezeVar` function to apply a variance shrinking Bayesian procedure to each M set of model results, 5) pooling the results with Rubins’ rules to produce combined coefficients, standard errors, and P-values, and 6) adjusting P-values for multiplicity to account for false discovery rate (FDR). 

A faster method uses principal component analysis (PCA) to avoid binning genes while still retaining outcome information in the MI models. Binning genes into smaller groups requires that the MI and limma-voom analysis is run many times (typically hundreds). The more computationally efficient MI PCA method implements covariate MI in gene expression studies by 1) performing PCA on the log CPM values for all genes using the Bioconductor `PCAtools` package, 2) creating M imputed datasets where the imputation predictor matrix includes all covariates and the optimum number of PCs to retain (e.g., based on Horn’s parallel analysis or the number of PCs that account for >80% explained variation), 3) conducting the standard limma-voom pipeline with the `voom` followed by `lmFit` followed by `eBayes` functions on each M imputed dataset, 4) pooling the results with Rubins’ rules to produce combined coefficients, standard errors, and P-values, and 5) adjusting P-values for multiplicity to account for false discovery rate (FDR).


# Installation

```{r, eval=FALSE}
# Install from github
library(devtools)
install_github("brennanhilton/RNAseqCovarImpute")

# Install from Bioconductor (not yet on Bioconductor)

if (!require("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("RNAseqCovarImpute")
```

# Generate random data with missing covariate data

Normally you would have your own covariate and RNA-sequencing data. We generated random data for the purpose of this demonstration. The exact code used to generate these data are found in the [Example Data for RNAseqCovarImpute](Example_Data_for_RNAseqCovarImpute.html) vignette. In short, `example_data` contains 500 rows with data for variables x, y, and z, which are continuous normally distributed, and a and b, which are binary variables. Missigness was simulated for all variables other than x such that a complete case analysis would drop 24.2% of participants. `example_DGE` contains random count data from the Poisson distribution for 500 made up genes, ENS1-ENS500
```{r}
library(RNAseqCovarImpute)
library(dplyr)
library(BiocParallel)
library(PCAtools)
library(limma)
library(mice)
data(example_data)
data(example_DGE)
```

# RNAseqCovarImpute Demonstration

## MI PCA method
We demonstrate the MI PCA method first, as it is far faster and performs just as well, or even better in many cases, compared with the original gene binning method.

### Conduct PCA

```{r}
# We use voom to convert counts to logCPM values, adding 0.5 to all the counts to avoid taking the logarithm of zero, and normalized for library size.
start.pca = Sys.time() # To calculate runtime
pca_data = limma::voom(example_DGE)$E
# Conduct pca
p = PCAtools::pca(pca_data)
# Determine the number of PCs that account for >80% explained variation
which(cumsum(p$variance) > 80)[1]
# Extract the PCs and append to our data
pcs = p$rotated[,1:78]
example_data = cbind(example_data, pcs)
```

### Conduct MI with mice

```{r}
# Conduct mice. In practice, m should be much larger (e.g., 10-100)
imp = mice::mice(example_data, m=3)
```

### Conduct limma-voom analysis
Now we use our `limmavoom_imputed_data_pca` function to run the standard limma-voom pipeline on each MI dataset and then pool the results with Rubins' rules.  This procedure is run in parallel using the BiocParallel package with the default back-end. Users can change the back-end using the `BPPARAM` argument. This argument is passed to `BiocParallel::bplapply`. For instance, below we specify to run `limmavoom_imputed_data_pca` in serial. Users specify the formula for the RNA-seq design matrix for which log fold-changes will be estimated. For each contrast specified in the voom_formula, p-values, coefficients, and standard errors are stored under the "_p", "_coef" and "_se" columns, respectively.

```{r}
mi_pca_res = RNAseqCovarImpute::limmavoom_imputed_data_pca(imp = imp,
                                                           DGE = example_DGE,
                                                           voom_formula = "~x + y + z + a + b",
                                                           BPPARAM = SerialParam())

# Display the results for the first 5 genes for the x variable in the model.
mi_pca_res[1:5, grep("^x", colnames(mi_pca_res))]
```

### Adjust for FDR
For a given contrast based on the variables in the design matrix (voom_formula), we arrange the genes from lowest to highest p-value and adjust for FDR.

```{r}
mi_pca_res_x = mi_pca_res %>% 
  arrange(x_p) %>% 
  mutate(x_p_adj = p.adjust(x_p, method = "fdr")) %>% 
  dplyr::select(probe, x_coef, x_p, x_p_adj)

end.pca = Sys.time() # To calculate runtime
time.pca = end.pca - start.pca # To calculate runtime
# Display the results for the first 5 genes
mi_pca_res_x[1:5,]
```

## Gene binning MI method

### Bin the genes into smaller groups
The default is approximately 1 gene per 10 individuals in the study, but the user can specify a different ratio. For example, in a study with 500 participants and 10,000 genes, 200 bins of 50 genes would be created using the default ratio. This example demonstrates why this method can be computationally intensive: the MI and limma-voom analysis will be conducted separately 200 times. When the total number of genes is not divisible by the bin size, the method flexibly creates bins of different sizes. The order of the features (e.g., ENSEMBL gene identifiers) should be randomized before binning. 

```{r}
# Get back the original example_data without the PCs appended
data(example_data)
start.old.method = Sys.time() # To calculate runtime
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
```

```{r, message=FALSE, warning=FALSE, echo=FALSE}
intervals %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The first 10 gene bins. Start and end columns indicate row numbers for the beginning and end of each bin. Number indicates the number of genes in each bin.")
```

Our goal is to bin genes randomly, so we must randomize the order of the genes in our DGE list. Without this step, genes would be binned together based on their sequential order within the chosen gene annotation (e.g., ENSEMBL or ENTREZ). 

```{r}
# Randomize the order of gene identifiers
annot <- example_DGE$genes
annot <- annot[sample(seq_len(nrow(annot))), ]
# Match order of the genes in the DGE to the randomized order of genes in the annotation
example_DGE <- example_DGE[annot, ]
```

### Make imputed data sets for each bin of genes and conduct differential expression analysis

Data are imputed using the mice R package with its default predictive modeling methods, which are predictive mean matching, logistic regression, polytomous regression, and proportional odds modeling for continuous, binary, categorical, and unordered variables, respectively. The user may specify “m”, the number of imputed datasets, and “maxit”, the number of iterations for each imputation (default = 10). M imputed datasets are created separately for each gene bin, where the imputation predictor matrix includes all covariates along with the log-CPM for all the genes in a particular bin. Thus, each gene bin contains M sets of imputed data. 

The `impute_by_gene_bin` function loops through a DGE list using the gene bin intervals from the `get_gene_bin_intervals` function. It returns a list of sets of m imputed datasets, one per gene bin. For instance, if m = 100 and intervals contains 200 gene bin intervals, output will be a list of 200 sets of 100 imputed datasets. Each of the 200 sets are imputed using only the genes in one gene bin.
```{r}
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3
)
```

This procedure is run in parallel using the BiocParallel package with the default back-end. Users can change the back-end using the `BPPARAM` argument. This argument is passed to `BiocParallel::bplapply`. For instance, to run `gene_bin_impute` in serial:
```{r}
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 3,
    BPPARAM = SerialParam()
)
```
### Estimate gene expression changes using voom followed by lmFit functions, separately on each M imputed dataset within each gene bin

The `limmavoom_imputed_data_list` function loops through the imputed data list (output from `impute_by_gene_bin` function) and runs RNA-seq analysis with the limma-voom pipeline. Users specify the formula for the RNA-seq design matrix for which log fold-changes will be estimated. This procedure can also be run with a different parallel back-end or in serial using the `BPPARAM` argument as above. 
```{r}
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 3,
    voom_formula = "~x + y + z + a + b"
)
```

### Apply variance shrinking Bayesian procedure, pooling results with Rubins’ rules, and FDR-adjust P-values

The final step is to combine the results from each imputed dataset using Rubin's rules. The argument "model_results" is the output from the `limmavoom_imputed_data_list` function above. The `combine_rubins` function applies the `squeezeVar` function before pooling results. The result is a table with one row per gene. The table includes coefficients (e.g., logFC values) standard errors, degrees of freedom, t-statistics, P-Values, and adjusted P-values from the limma-voom pipeline. Both the raw and empirical Bayes moderated statistics are reported. The user selects the predictor of interest in the form of a linear model contrast for which model results will be extracted. For a continuous variable this is just the predictor name. For a categorical variable like `b` in `example_data` we could specify `predictor = b1` to get the effect of being in the b = 1 versus the b = 0 group.
```{r}
final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)

end.old.method = Sys.time() # To calculate runtime
time.old.method = end.old.method - start.old.method
```


```{r, message=FALSE, warning=FALSE, echo=FALSE}
final_res %>%
    dplyr::select(probe, coef_combined, combined_p_bayes, combined_p_adj_bayes) %>%
    head(10) %>%
    knitr::kable(digits = 3, caption = "The top 10 genes associated with predictor x sorted by lowest P-value")
```

The old method took more time(`time.old.method`) compared with the MI PCA method (`time.pca`).

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/voom_sx_sy.R
\name{voom_sx_sy}
\alias{voom_sx_sy}
\title{voom_sx_sy}
\usage{
voom_sx_sy(
  counts,
  design = NULL,
  lib.size = NULL,
  normalize.method = "none",
  block = NULL,
  correlation = NULL,
  weights = NULL,
  span = 0.5,
  plot = FALSE,
  save.plot = FALSE,
  lib.size.all
)
}
\value{
Tibble with one col for sx and one for sy for lowess function.
}
\description{
Modified voom function used by limma_voom-imputed_data_list function.
Allows input of bins of outcome genes while still accounting for the total library size
of all outcome genes, as the total library size is needed to calculate log-cpm values.
Returns just the sx and sy values needed for lowess curve. Adapted from limma::voom.
Code from limma covered by License: GPL (>=2)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/limmavoom_imputed_data_list.R
\name{limmavoom_imputed_data_list}
\alias{limmavoom_imputed_data_list}
\title{limmavoom_imputed_data_list}
\usage{
limmavoom_imputed_data_list(
  gene_intervals,
  DGE,
  imputed_data_list,
  m,
  voom_formula,
  BPPARAM = bpparam()
)
}
\arguments{
\item{gene_intervals}{Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.}

\item{DGE}{A DGEList object.}

\item{imputed_data_list}{Output from impute_by_gene_bin.}

\item{m}{Number of imputed data sets.}

\item{voom_formula}{Formula for design matrix.}

\item{BPPARAM}{A BiocParallelParam object}
}
\value{
A dataframe with coefficient, standard error, sigma, and residual degrees of freedom values from limma-voom gene expression analysis. One row per gene and one set of values per imputed dataset.
}
\description{
Loops through the imputed data list (output from "impute_by_gene_bin" function)
and runs limma-voom RNA seq analysis.
}
\examples{
data(example_data)
data(example_DGE)
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 2
)
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 2,
    voom_formula = "~x + y + z + a + b"
)

final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/impute_by_gene_bin.R
\name{impute_by_gene_bin}
\alias{impute_by_gene_bin}
\title{impute_by_gene_bin}
\usage{
impute_by_gene_bin(data, intervals, DGE, m, maxit = 10, BPPARAM = bpparam())
}
\arguments{
\item{data}{Sample data with one row per sample. Sample row order should match the col order in the DGEList.}

\item{intervals}{Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.}

\item{DGE}{A DGEList object.}

\item{m}{Number of imputed data sets.}

\item{maxit}{Used by mice function.}

\item{BPPARAM}{A BiocParallelParam object}
}
\value{
A list of sets of n imputed datasets, one per gene bin.
}
\description{
Loops through DGE list using the gene bin intervals from the
"get_gene_bin_intervals" function and makes imputed datasets. For instance,
if n = 100 and intervals contains 200 gene bin intervals, output will be a list of
200 sets of 100 imputed datasets. Each of the 200 sets are imputed
using only the genes in one gene bin.
}
\examples{
data(example_data)
data(example_DGE)
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 2
)
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 2,
    voom_formula = "~x + y + z + a + b"
)

final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine_rubins.R
\name{combine_rubins}
\alias{combine_rubins}
\title{combine_rubins}
\usage{
combine_rubins(
  DGE,
  model_results,
  predictor,
  covariate = NULL,
  robust = FALSE,
  winsor.tail.p = c(0.05, 0.1)
)
}
\arguments{
\item{DGE}{A DGEList object.}

\item{model_results}{Output from limmavoom_imputed_datalist.}

\item{predictor}{Independent variable of interest, in the form of a linear model contrast. Must be a variable in voom_formula.}

\item{covariate}{Arguments passed to limma::squeezeVar. If non-NULL, var.prior will depend on this numeric covariate. Otherwise, var.prior is constant.}

\item{robust}{Arguments passed to limma::squeezeVar. Llogical, should the estimation of df.prior and var.prior be robustified against outlier sample variances?}

\item{winsor.tail.p}{Arguments passed to limma::squeezeVar. Numeric vector of length 1 or 2, giving left and right tail proportions of x to Winsorize. Used only when robust=TRUE.}
}
\value{
Dataframe with one row per gene containing coefficients standard errors, degrees of freedom, t-statistics, P-Values, and adjusted P-values from the limma-voom pipeline.
\item{coef_combined}{combined logFCs across the multiple imputed datasets using Rubin's rules}
\item{SE_P}{pooled standard error across the multiple imputed datasets using Rubin's rules}
\item{SE_P_bayes}{pooled standard error across the multiple imputed datasets using Rubin's rules squeezed to global mean variance trend curve with limma-voom Bayesian procedure}
\item{df}{limma-voom residual degrees of freedom adjusted for Rubin's rules}
\item{df_bayes}{limma-voom residual degrees of freedom adjusted for Rubin's rules and Bayesian procedure}
\item{rubins_t}{t-statistic = coef_combined divided by SE_p}
\item{rubins_t_bayes}{t-statistic = coef_combined divided by SE_p_bayes}
\item{combined_p}{p-value from two-sided t-distribution alpha = 0.05 using rubins_t}
\item{combined_p_bayes}{p-value from two-sided t-distribution alpha = 0.05 using rubins_t_bayes}
\item{combined_p_adj}{false discovery rate (FDR) adjusted combined_p}
\item{combined_p_adj_bayes}{false discovery rate (FDR) adjusted combined_p_bayes}
}
\description{
Combines results from each imputed dataset using Rubin's rules.
}
\examples{
data(example_data)
data(example_DGE)
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 2
)
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 2,
    voom_formula = "~x + y + z + a + b"
)

final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_gene_bin_intervals.R
\name{get_gene_bin_intervals}
\alias{get_gene_bin_intervals}
\title{get_gene_bin_intervals}
\usage{
get_gene_bin_intervals(DGE, data, n = 10)
}
\arguments{
\item{DGE}{A DGEList object.}

\item{data}{Sample data with one row per sample. Sample row order should match the col order in the DGEList.}

\item{n}{Genes per bin are set so that each bin has approximately 1 gene per n individuals in the data.}
}
\value{
Data frame with one row per gene bin. Columns indicate the start and end positions and the number of genes of each bin.
}
\description{
Creates gene bins. Input DGE list, sample data,
and 'n' number of individuals per genes. By default, number of bins and
genes per bin are set so that each bin has approximately 1 gene per
10 individuals in the data.
}
\examples{
data(example_data)
data(example_DGE)
intervals <- get_gene_bin_intervals(example_DGE, example_data, n = 10)
gene_bin_impute <- impute_by_gene_bin(example_data,
    intervals,
    example_DGE,
    m = 2
)
coef_se <- limmavoom_imputed_data_list(
    gene_intervals = intervals,
    DGE = example_DGE,
    imputed_data_list = gene_bin_impute,
    m = 2,
    voom_formula = "~x + y + z + a + b"
)

final_res <- combine_rubins(
    DGE = example_DGE,
    model_results = coef_se,
    predictor = "x"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine_rubins_pca.R
\name{combine_rubins_pca}
\alias{combine_rubins_pca}
\title{combine_rubins_pca}
\usage{
combine_rubins_pca(gene, results_final, avg_df, m)
}
\arguments{
\item{gene}{The number gene in the DGE list.}

\item{results_final}{List with one element per gene storing coefficients and standard errors from limma-voom analysis.}

\item{avg_df}{The average df.total from limma-voom analysis across the m imputed datasets.}

\item{m}{Number of imputed data sets.}
}
\value{
Coefficient, standard error, and p-value combined across m imputed datasets.
}
\description{
Combines results from each imputed dataset using Rubin's rules.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lowess_all_gene_bins.R
\name{lowess_all_gene_bins}
\alias{lowess_all_gene_bins}
\title{lowess_all_gene_bins}
\usage{
lowess_all_gene_bins(gene_intervals, DGE, imputed_data_list, m, voom_formula)
}
\value{
All sx and sy values for lowess function across all M imputations.
}
\description{
Loops through all bins and all M imputations, prepares DGE and design to run
voom_sx_sy, which fits gene-wise linear models and extracts log count size (sx)
and sqrt resudual standard deviations (sy) to make the lowess curve
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/limmavoom_imputed_data_pca_helper.R
\name{limmavoom_imputed_data_pca_helper}
\alias{limmavoom_imputed_data_pca_helper}
\title{limmavoom_imputed_data_pca_helper}
\usage{
limmavoom_imputed_data_pca_helper(i, imp, DGE, voom_formula)
}
\arguments{
\item{i}{Number from 1-m}

\item{imp}{Imputed data from mice (mids object)}

\item{DGE}{A DGEList object.}

\item{voom_formula}{Formula for design matrix.}
}
\value{
A list with coefficients, standard errors, and total degrees of freedom values from limma-voom gene expression analysis.
}
\description{
Runs limma-voom pipeline on one of the m imputed datasets and returns the coefficients,
Bayesian moderated standard errors and degrees of freedom.
This function used while looping through the m imputed datasets.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/impute_by_gene_bin_helper.R
\name{impute_gene_bin_helper}
\alias{impute_gene_bin_helper}
\title{impute_by_gene_bin_helper}
\usage{
impute_gene_bin_helper(i, intervals, cpm_all, data, m, maxit)
}
\arguments{
\item{intervals}{Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.}

\item{data}{Sample data with one row per sample. Sample row order should match the col order in the DGEList.}

\item{m}{Number of imputed data sets.}

\item{maxit}{Used by mice function.}

\item{DGE}{A DGEList object.}

\item{param}{Arguments passed to BiocParallel::bpparam()}
}
\value{
A list of sets of n imputed datasets, one per gene bin.
}
\description{
Loops through DGE list using the gene bin intervals from the
"get_gene_bin_intervals" function and makes imputed datasets. For instance,
if n = 100 and intervals contains 200 gene bin intervals, output will be a list of
200 sets of 100 imputed datasets. Each of the 200 sets are imputed
using only the genes in one gene bin.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_DGE.R
\docType{data}
\name{example_DGE}
\alias{example_DGE}
\title{Simulated counts in DGE list}
\format{
\subsection{\code{example_DGE}}{

A DGElist with 500 genes and 500 samples
}
}
\usage{
data(example_DGE)
}
\value{
DGElist for 500 made up genes, ENS1-ENS500
}
\description{
The exact code used to generate these data are found in the Example_Data_for_RNAseqCovarImpute
vignette. In short, \code{example_data} contains 500 rows with data for variables x, y, and z, which
are continuous normally distributed, and a and b, which are binary variables. Missigness
was simulated for all variables other than x such that a complete case analysis would drop
24.2\% of participants. \code{example_DGE} contains random count data from the Poisson distribution
for 500 made up genes, ENS1-ENS500
}
\examples{
data(example_DGE)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAseqCovarImpute-package.R
\docType{package}
\name{RNAseqCovarImpute-package}
\alias{RNAseqCovarImpute}
\alias{RNAseqCovarImpute-package}
\title{RNAseqCovarImpute: Impute Covariate Data in RNA Sequencing Studies}
\description{
The RNAseqCovarImpute package makes linear model analysis for RNA sequencing read counts compatible with multiple imputation (MI) of missing covariates. A major problem with implementing MI in RNA sequencing studies is that the outcome data must be included in the imputation prediction models to avoid bias. This is difficult in omics studies with high-dimensional data. The first method we developed in the RNAseqCovarImpute package surmounts the problem of high-dimensional outcome data by binning genes into smaller groups to analyze pseudo-independently. This method implements covariate MI in gene expression studies by 1) randomly binning genes into smaller groups, 2) creating M imputed datasets separately within each bin, where the imputation predictor matrix includes all covariates and the log counts per million (CPM) for the genes within each bin, 3) estimating gene expression changes using `limma::voom` followed by `limma::lmFit` functions, separately on each M imputed dataset within each gene bin, 4) un-binning the gene sets and stacking the M sets of model results before applying the `limma::squeezeVar` function to apply a variance shrinking Bayesian procedure to each M set of model results, 5) pooling the results with Rubins’ rules to produce combined coefficients, standard errors, and P-values, and 6) adjusting P-values for multiplicity to account for false discovery rate (FDR). A faster method uses principal component analysis (PCA) to avoid binning genes while still retaining outcome information in the MI models. Binning genes into smaller groups requires that the MI and limma-voom analysis is run many times (typically hundreds). The more computationally efficient MI PCA method implements covariate MI in gene expression studies by 1) performing PCA on the log CPM values for all genes using the Bioconductor `PCAtools` package, 2) creating M imputed datasets where the imputation predictor matrix includes all covariates and the optimum number of PCs to retain (e.g., based on Horn’s parallel analysis or the number of PCs that account for >80% explained variation), 3) conducting the standard limma-voom pipeline with the `voom` followed by `lmFit` followed by `eBayes` functions on each M imputed dataset, 4) pooling the results with Rubins’ rules to produce combined coefficients, standard errors, and P-values, and 5) adjusting P-values for multiplicity to account for false discovery rate (FDR).
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/brennanhilton/RNAseqCovarImpute}
  \item Report bugs at \url{https://github.com/brennanhilton/RNAseqCovarImpute/issues}
}

}
\author{
\strong{Maintainer}: Brennan Baker \email{brennanhilton@gmail.com} (\href{https://orcid.org/0000-0001-5459-9141}{ORCID})

Authors:
\itemize{
  \item Sheela Sathyanarayana
  \item Adam Szpiro
  \item James MacDonald
  \item Alison Paquette
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/limmavoom_imputed_data_pca.R
\name{limmavoom_imputed_data_pca}
\alias{limmavoom_imputed_data_pca}
\title{limmavoom_imputed_data_pca}
\usage{
limmavoom_imputed_data_pca(imp, DGE, voom_formula, BPPARAM = bpparam())
}
\arguments{
\item{imp}{Imputed data from mice (mids object)}

\item{DGE}{A DGEList object.}

\item{voom_formula}{Formula for design matrix.}

\item{BPPARAM}{A BiocParallelParam object}
}
\value{
Dataframe with one row per gene. Columns contain coefficients, standard errors, and p-values from the limma-voom pipeline.
}
\description{
Combines results from each imputed dataset using Rubin's rules.
}
\examples{
data(example_data)
data(example_DGE)
pca_data = limma::voom(example_DGE)$E
p = PCAtools::pca(pca_data)
pcs = p$rotated[,1:78]
example_data = cbind(example_data, pcs)
imp = mice::mice(example_data, m=3)
mi_pca_res = limmavoom_imputed_data_pca(
   imp = imp,
   DGE = example_DGE,
   voom_formula = "~x + y + z + a + b"
   )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/voom_master_lowess.R
\name{voom_master_lowess}
\alias{voom_master_lowess}
\title{voom_master_lowess}
\usage{
voom_master_lowess(
  counts,
  design = NULL,
  lib.size = NULL,
  normalize.method = "none",
  block = NULL,
  correlation = NULL,
  weights = NULL,
  span = 0.5,
  plot = FALSE,
  save.plot = FALSE,
  lib.size.all,
  sx,
  sy
)
}
\value{
Same as limma::voom.
}
\description{
Modified voom function used by limma_voom-imputed_data_list function.
Allows input of bins of outcome genes while still accounting for the total library size
of all outcome genes, as the total library size is needed to calculate log-cpm values.
Also allows use of external sx and sy to create lowess curve. Here, sx and sy should
come from all gene bins across all M imputations. Adapted from limma::voom.
Code from limma covered by License: GPL (>=2)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/limmavoom_imputed_data_list_helper.R
\name{limmavoom_imputed_data_list_helper}
\alias{limmavoom_imputed_data_list_helper}
\title{limmavoom_imputed_data_list_helper}
\usage{
limmavoom_imputed_data_list_helper(
  gene_bin,
  gene_intervals,
  DGE,
  imputed_data_list,
  m,
  voom_formula,
  sx_sy
)
}
\arguments{
\item{gene_intervals}{Output from get_gene_bin_intervals function. A dataframe where each row contains the start (first col) and end (second col) values for each gene bin interval.}

\item{DGE}{A DGEList object.}

\item{imputed_data_list}{Output from impute_by_gene_bin.}

\item{m}{Number of imputed data sets.}

\item{voom_formula}{Formula for design matrix.}
}
\value{
A dataframe with coefficient, standard error, sigma, and residual degrees of freedom values from limma-voom gene expression analysis. One row per gene and one set of values per imputed dataset.
}
\description{
Loops through the imputed data list (output from "impute_by_gene_bin" function)
and runs limma-voom RNA seq analysis.
}
\keyword{internal}
